#ifndef POPBOX_H
#define POPBOX_H
#include <qobject.h>
#include <qsocket.h>
#include <qstring.h>
#include <qtextstream.h>
#include <qdns.h>
#include <qtimer.h>

class Popbox : public QObject
{
	Q_OBJECT

	public :
		Popbox(QString f_popserver, QString f_user, QString f_password);
		~Popbox();
		void changeBox(QString f_popserver, QString f_user, QString f_password);
		void requestPop();

	signals :
		void popResponse(int errorCode, int nbMess = -1);
		/*
			errorCode : 
				0 = OK
				1 = DNS Lookup error
				2 = Server refused connection
				3 = User authentication failed
				4 = Reading Statistics failed
				5 = Connection timeout
		*/

	private :
		bool isOk(QString resp);

		QSocket *popSocket;
		QString popserver, user, password;
		QTextStream *socketBuf;
		QDns *serverLookup;
		QTimer *timerTimeout;

		enum State {S_INIT, S_USER, S_PASS, S_STAT, S_QUIT};
		int state;

	private slots :
		void socketRead();
		void socketConnected();
		void socketTimeout();
		void connectServer();
};

#endif
